#! /bin/sh

DOMAIN="My.Domain"
VUSER="virtual_mail"
MUSER="mail"
DMAIL="/var/spool/mail"

ALIASSES="/etc/postfix/aliases"

USERDB="/usr/sbin/userdb"
#USERDB="echo"

GREP="/bin/grep"
FGREP="/bin/fgrep"
CUT="/bin/cut"
CHOWN="/bin/chown"
HOSTNAME="/bin/hostname"
APG="/usr/bin/apg"
ID="/usr/bin/id"
USERDBPW="/usr/sbin/userdbpw"
MAKEUSERDB="/usr/sbin/makeuserdb"
MAILDIRMAKE="/usr/bin/maildirmake"
GETOPT="/usr/bin/getopt"
TR="/usr/bin/tr"

PARAMTEMP=`$GETOPT -o s:p:h -l synonym:,password:,help -n "$0" -- $@`
eval set -- "$PARAMTEMP"

SNAME=""
NAME=""
Passwd=""

while true
do
	case "$1" in
		-s|--synonym)
			MNAME=`echo "$2" | $TR '[:upper:]' '[:lower:]'`
			echo "$MNAME" | $GREP -q '[^a-z0-9_.-]' && {
				echo "Error:   $1    [A-Za-z0-9_.-] !"
				exit 1
			}
			shift 2
			;;
		-p|--password)
			PASSWD="$2"
			shift 2
			;;
		-h|--help)
			echo "$0 [-s|--synonym <synonym>] [-p|--password <password>] [-h|--help] <name>"
			exit 0
			;;
		--)
			shift
			break
			;;
		*)
			echo "Error:  $1 - !"
			exit 1
			;;
	esac
done

VUID="`$ID -u \"$VUSER\"`"
MGID="`$ID -g \"$MUSER\"`"
if test "x$VUID" = "x"; then
	echo "No set user for virtual domen"
	exit 2
elif test "x$1" = "x"; then
	echo "No mail name"
	exit 3
fi

NAME=`echo "$1" | $TR '[:upper:]' '[:lower:]'`
echo "$NAME"

echo "$NAME" | $GREP -q '[a-z][^a-z0-9_-]' && {
	echo "No valid mail name"
	exit 4
}

MNAME="${MNAME:-"$NAME"}"

#if test "x$NAME" = "x"; then
#	NAME=`echo "$MNAME" | $TR '.' '_'`
#fi

MUID=`$ID -u "$NAME" 2>/dev/null||echo "$VUID"`
if test "x$MUID" = "x$VUID"; then
	MAIL="$DMAIL/$VUSER/$NAME"
	UHOME="$MAIL"
else
	MAIL="$DMAIL/$NAME"
	UHOME="`$GREP \"^$NAME:\" /etc/passwd|$CUT -f6 -d:`"
fi

MAILNAME="${NAME}@$DOMAIN"

MPASSWORD="${PASSWD:-`$APG -n 1`}"
SMPASSWORD="`echo $MPASSWORD|$USERDBPW`"

$MAILDIRMAKE "$MAIL"
$MAILDIRMAKE -f Sent "$MAIL"
$MAILDIRMAKE -f Drafts "$MAIL"
$MAILDIRMAKE -f Templates "$MAIL"
$CHOWN -R "$MUID":"$MGID" "$MAIL"
$USERDB $MAILNAME set home="$UHOME" mail="$MAIL" uid="$MUID" gid="$MGID" \
	imappw="$SMPASSWORD" pop3pw="$SMPASSWORD"

test "x$NAME" = "x$MNAME" || ($GREP -q "^${NAME}:" "$ALIASSES" || (echo "${MNAME}:	$NAME" >> $ALIASSES))
#test "x$NAME" = "x$MNAME" || (echo "${MNAME}:	$NAME" )

echo "user:" "${MNAME}@$DOMAIN" "$MAILNAME" "$MPASSWORD" "$MAIL" "$UHOME"

